# DragonOS

## 打造完全自主可控的数字化未来！

--- 

**Languages** 中文|[English](README_EN.md)

&nbsp;

&emsp;&emsp;DragonOS龙操作系统（以下简称“DragonOS”）是一个面向服务器领域的，从0开发内核及用户态环境，并提供Linux兼容性的64位操作系统。它使用Rust与C语言进行编写，并正在逐步淘汰原有的C代码，以在将来提供更好的安全性与可靠性。

&emsp;&emsp;DragonOS的目标是，构建一个完全独立自主的、开源的、高性能及高可靠性的服务器操作系统，为国家数字基础设施建设提供完全独立自主的底层核心动力。

&emsp;&emsp;作为一个社区驱动的开源操作系统，为了促进其发展，避免让其遭受一些不遵守开源协议的商业公司的侵权，我们决定使用GPLv2协议开放源代码，以严格的开源协议来保护DragonOS。

[关于DragonOS，你想了解的都在这儿 - DragonOS](https://dragonos.org/?p=46)

## 网站

- 项目官网  **[DragonOS.org](https://dragonos.org)**

- 项目文档  **[docs.DragonOS.org](https://docs.dragonos.org)**

- **了解开发动态、开发任务，请访问DragonOS的zulip社群**： [https://DragonOS.zulipchat.com](https://DragonOS.zulipchat.com)

- 开源论坛  **[bbs.DragonOS.org](https://bbs.dragonos.org)**

- 软件镜像站 **[mirrors.DragonOS.org](https://mirrors.DragonOS.org)**

- 开发交流QQ群 **115763565**

- 代码搜索引擎 [code.DragonOS.org](http://code.dragonos.org)
  
  &nbsp;

## 如何运行？

&emsp;&emsp;运行DragonOS的步骤非常简单，您可以参考以下几个资料，在最短15分钟内运行DragonOS！

- [构建DragonOS — DragonOS dev 文档](https://docs.dragonos.org/zh_CN/latest/introduction/build_system.html)

- [教你在15分钟内运行DragonOS！- Bilibili](https://www.bilibili.com/video/BV1zF411w7s2?share_source=copy_web&vd_source=41ab4a1b73e6f65219a785923511517e)

## 系统特性

&emsp;&emsp;请参见文档：[系统特性](https://docs.dragonos.org/zh_CN/latest/introduction/features.html)

## 如何加入？

&emsp;&emsp;如果你愿意加入我们，你可以访问DragonOS的zulip社群，了解开发动态、开发任务： [https://DragonOS.zulipchat.com](https://DragonOS.zulipchat.com)

&emsp;&emsp;你也可以带着你的创意与想法，和社区的小伙伴一起讨论，为DragonOS创造一些新的功能。

## 如何与社区建立联系？

&emsp;&emsp;你可以发邮件给Maintainer: longjin，邮件地址是 [longjin@DragonOS.org](mailto:longjin@DragonOS.org) 。

&emsp;&emsp;或者是加入我们的开发交流QQ群：**115763565**

&emsp;&emsp;对于正式问题的讨论，我们建议在 **[DragonOS的zulip社群](https://DragonOS.zulipchat.com)** 上的对应板块，使用正式的语言发帖讨论。亦或者是在本仓库的issue下提出问题。


## 贡献者名单

[Contributors to DragonOS-Community/DragonOS · GitHub](https://github.com/DragonOS-Community/DragonOS/graphs/contributors)

## 联系我们

社区对外联系邮箱：contact@DragonOS.org

社区负责人邮箱：longjin@DragonOS.org

## 赞助

&emsp;&emsp;DragonOS是一个公益性质的开源项目，但是它的发展离不开资金的支持，如果您愿意的话，可以通过 **[赞助 - DragonOS](https://dragonos.org/?page_id=37)** ，从而促进这个项目的发展。所有的赞助者的名单都会被公示。您的每一分赞助，都会为DragonOS的发展作出贡献！

### 赞助的资金都会被用到哪里？

我们保证，所有赞助的资金及物品，将会用于：

- 为活跃的社区开发者发放补贴或设备支持

- DragonOS的云服务开支

- 设备购置

- 任何有助于DragonOS发展建设的用途

### 赞助商列表

**暂无**

我们期望在未来，能有企业赞助DragonOS，为它的发展注入资金动力！

### 个人赞赏者列表

- 万晓兰
- David Wen
- [Seele.Clover](https://github.com/seeleclover)
- [FindWangHao](https://github.com/FindWangHao)
- [ferchiel](https://github.com/ferchiel)
- 叶锦毅
- 林
- Albert
- [TerryLeeSCUT · GitHub](https://github.com/TerryLeeSCUT)
- slientbard
- 悟

## 开放源代码声明

本项目采用GPLv2协议进行开源，欢迎您在遵守开源协议的基础之上，使用本项目的代码！

**我们支持**：遵守协议的情况下，利用此项目，创造更大的价值，并为本项目贡献代码。

**我们谴责**：任何不遵守开源协议的行为。包括但不限于：剽窃该项目的代码作为你的毕业设计等学术不端行为以及商业闭源使用而不付费。

若您发现了任何违背开源协议的使用行为，我们欢迎您发邮件反馈！让我们共同建设诚信的开源社区。

## 参考资料

&emsp;&emsp;本项目参考了以下资料，我对这些项目、书籍、文档的作者表示感谢！

- 《一个64位操作系统的实现》田宇（人民邮电出版社）

- 《现代操作系统 原理与实现》陈海波、夏虞斌（机械工业出版社）

- [SimpleKernel](https://github.com/Simple-XX/SimpleKernel)

- [osdev.org](https://wiki.osdev.org/Main_Page)

- ACPI_6_3_final_Jan30

- the GNU GRUB manual

- Intel® 64 and IA-32 Architectures Software Developer’s Manual

- IA-PC HPET (High Precision Event Timers) Specification

- [skiftOS]([GitHub - skiftOS/skift: 🥑 A hobby operating system built from scratch in modern C++. Featuring a reactive UI library and a strong emphasis on user experience.](https://github.com/skiftOS/skift))

- [GuideOS](https://github.com/Codetector1374/GuideOS)

- [redox-os](https://gitlab.redox-os.org/redox-os/redox)

- [rcore](https://github.com/rcore-os/rCore)
