# DragonOS

**Languages** [中文](README.md)|English

&nbsp;

&emsp;&emsp;DragonOS is an operating system running on the X86_64 Architecture. This project is currently under development!

[All you want to know about DragonOS is here - DragonOS](https://dragonos.org/?p=46)

## Websites

- Home Page  **[DragonOS.org](https://dragonos.org)**
- Documentation  **[docs.DragonOS.org](https://docs.dragonos.org)**
- **To learn about development dynamics and development tasks, please visit DragonOS's zulip community:** [https://DragonOS.zulipchat.com](https://DragonOS.zulipchat.com)
- BBS  **[bbs.DragonOS.org](https://bbs.dragonos.org)**
- Software mirror website **[mirrors.DragonOS.org](https://mirrors.DragonOS.org)**
- QQ group **115763565**
- Code search engine [code.DragonOS.org](http://code.dragonos.org)&nbsp;

## How to run?

&emsp;&emsp;The steps to run DragonOS are very simple. You can refer to the following information to run DragonOS within 15 minutes at the fastest!

- [Building DragonOS - DragonOS dev document](https://docs.dragonos.org/zh_CN/latest/introduction/build_system.html)

- [Teach you to run DragonOS in 15 minutes- Bilibili](https://www.bilibili.com/video/BV1zF411w7s2?share_source=copy_web&vd_source=41ab4a1b73e6f65219a785923511517e)

## DragonOS' Features

&emsp;&emsp;See documentation:[Features](https://docs.dragonos.org/zh_CN/latest/introduction/features.html)

## How to join DragonOS ?

&emsp;&emsp;If you are willing to join us, you can visit DragonOS's zulip community, learn about development dynamics and development tasks: [https://DragonOS.zulipchat.com](https://DragonOS.zulipchat.com)

&emsp;&emsp;Or, you can also bring your ideas, discuss with community members, and create some new functions for DragonOS.

## How to contact the community?

&emsp;&emsp;You can send an email to the project's maintainer: longjin. His email address is [longjin@DragonOS.org](mailto: longjin@DragonOS.org) .

&emsp;&emsp;Or join our development exchange QQ group: **115763565**

&emsp;&emsp;For the discussion of formal issues, we recommend that you use the official language to post on the corresponding section of **[DragonOS's zulip community](https://DragonOS.zulipchat.com)**. Or you can post questions under the issue of this repository.


## List of contributors

[Contributors to DragonOS-Community/DragonOS · GitHub](https://github.com/DragonOS-Community/DragonOS/graphs/contributors)

## Get contact with us

Community Contact Email: contact@DragonOS.org

Maintainer longjin's Email：longjin@DragonOS.org


## Reward

&emsp;&emsp;DragonOS is an open source public welfare project, but its development cannot be separated from the support of funds. If you want, you can visit **[Sponsor - DragonOS](https://dragonos.org/?page_id=37)** , so as to promote the development of this project. The list of all sponsors will be published. Every bit of your sponsorship will contribute to the development of DragonOS!

### Where will the sponsorship funds be used?

We guarantee that all sponsorship funds and items will be used for:

- Subsidies or equipment support for active community developers
- Cloud service expenditure of DragonOS
- Equipment purchase
- Any use conducive to the development and construction of DragonOS

### Sponsor List

**Not yet**

We hope that in the future, some enterprises can sponsor DragonOS and inject financial power into its development!

### Individual Sponsor List

- 万晓兰
- David Wen
- [Seele.Clover](https://github.com/seeleclover)
- [FindWangHao](https://github.com/FindWangHao)
- [ferchiel](https://github.com/ferchiel)
- 叶锦毅
- 林
- Albert
- [TerryLeeSCUT · GitHub](https://github.com/TerryLeeSCUT)
- slientbard
- 悟

## Open source statement

&emsp;&emsp;This project adopts GPLv2 LICENSE for open source. You are welcome to use the code of this project on the basis of abiding by the open source license!

**What we support:** using this project to create greater value and contribute code to this project under the condition of abiding by the agreement.

**What we condemn**: any non-compliance with the open source license. Including but not limited to: plagiarizing the code of the project as your graduation project and other academic misconduct, as well as commercial closed source use without payment.

If you find any violation of the open source license, we welcome you to send email feedback! Let's build an honest open source community together!

## References

&emsp;&emsp;This project refers to the following materials. I sincerely give my thanks to the authors of these projects, books and documents!

- Implementation of a 64 bit operating system, Tian Yu (POSTS&TELECOM  PRESS)

- Principle and implementation of modern operating system, Chen Haibo, Xia Yubin (China Machine Press)

- [SimpleKernel](https://github.com/Simple-XX/SimpleKernel)

- [osdev.org](https://wiki.osdev.org/Main_Page)

- ACPI_6_3_final_Jan30

- the GNU GRUB manual

- Intel® 64 and IA-32 Architectures Software Developer’s Manual

- IA-PC HPET (High Precision Event Timers) Specification

- [skiftOS]([GitHub - skiftOS/skift: 🥑 A hobby operating system built from scratch in modern C++. Featuring a reactive UI library and a strong emphasis on user experience.](https://github.com/skiftOS/skift))

- [GuideOS](https://github.com/Codetector1374/GuideOS)

- [redox-os](https://gitlab.redox-os.org/redox-os/redox)

- [rcore](https://github.com/rcore-os/rCore)
